## mongodb 2.6.3

=== SConstruct ===
# -*- mode: python; -*-
# build file for MongoDB
# this requires scons
# you can get from http://www.scons.org
# then just type scons

# some common tasks
#   build 64-bit mac and pushing to s3
#      scons --64 s3dist
#      scons --distname=0.8 s3dist
#      all s3 pushes require settings.py and simples3

# This file, SConstruct, configures the build environment, and then delegates to
# several, subordinate SConscript files, which describe specific build rules.

import buildscripts
import copy
import datetime
import imp
import os
import re
import shutil
import stat
import sys
import textwrap
import types
import urllib
import urllib2
from buildscripts import utils
from buildscripts import moduleconfig

import libdeps

EnsureSConsVersion( 1, 1, 0 )
if "uname" in dir(os):
    scons_data_dir = ".scons/%s/%s" % ( os.uname()[0] , os.getenv( "HOST" , "nohost" ) )
else:
    scons_data_dir = ".scons/%s/" % os.getenv( "HOST" , "nohost" )
SConsignFile( scons_data_dir + "/sconsign" )

DEFAULT_INSTALL_DIR = "/usr/local"


def findSettingsSetup():
    sys.path.append( "." )
    sys.path.append( ".." )
    sys.path.append( "../../" )

def versiontuple(v):
    return tuple(map(int, (v.split("."))))

# --- platform identification ---
#
# This needs to precede the options section so that we can only offer some options on certain
# platforms.

platform = os.sys.platform
nix = False
linux = False
darwin = False
windows = False
freebsd = False
openbsd = False
solaris = False

if "darwin" == platform:
    darwin = True
    platform = "osx" # prettier than darwin
elif platform.startswith("linux"):
    linux = True
    platform = "linux"
elif "sunos5" == platform:
    solaris = True
elif platform.startswith( "freebsd" ):
    freebsd = True
elif platform.startswith( "openbsd" ):
    openbsd = True
elif "win32" == platform:
    windows = True
else:
    print( "No special config for [" + platform + "] which probably means it won't work" )

nix = not windows

# --- options ----
use_clang = False

options = {}

def add_option( name, help, nargs, contributesToVariantDir,
                dest=None, default = None, type="string", choices=None, metavar=None ):

    if dest is None:
        dest = name

    if type == 'choice' and not metavar:
        metavar = '[' + '|'.join(choices) + ']'

    AddOption( "--" + name , 
               dest=dest,
               type=type,
               nargs=nargs,
               action="store",
               choices=choices,
               default=default,
               metavar=metavar,
               help=help )

    options[name] = { "help" : help ,
                      "nargs" : nargs ,
                      "contributesToVariantDir" : contributesToVariantDir ,
                      "dest" : dest,
                      "default": default }

def get_option( name ):
    return GetOption( name )

def has_option( name ):
    x = get_option( name )
    if x is None:
        return False

    if x == False:
        return False

    if x == "":
        return False

    return True

def use_system_version_of_library(name):
    return has_option('use-system-all') or has_option('use-system-' + name)

def get_variant_dir():
    if has_option('variant-dir'):
        return "#build/" + get_option('variant-dir') 

    substitute = lambda x: re.sub( "[:,\\\\/]" , "_" , x )

    a = []

    for name in options:
        o = options[name]
        if not has_option( o["dest"] ):
            continue
        if not o["contributesToVariantDir"]:
            continue
        if get_option(o["dest"]) == o["default"]:
            continue

        if o["nargs"] == 0:
            a.append( name )
        else:
            x = substitute( get_option( name ) )
            a.append( name + "_" + x )

    extras = []
    if has_option("extra-variant-dirs"):
        extras = [substitute(x) for x in get_option( 'extra-variant-dirs' ).split( ',' )]

    if has_option("add-branch-to-variant-dir"):
        extras += ["branch_" + substitute( utils.getGitBranch() )]

    if has_option('cache'):
        s = "#build/cached/"
        s += "/".join(extras) + "/"
    else:
        s = "#build/${PYSYSPLATFORM}/"
        a += extras

        if len(a) > 0:
            a.sort()
            s += "/".join( a ) + "/"
        else:
            s += "normal/"

    return s

# build output
add_option( "mute" , "do not display commandlines for compiling and linking, to reduce screen noise", 0, False )

# installation/packaging
add_option( "prefix" , "installation prefix" , 1 , False, default=DEFAULT_INSTALL_DIR )
add_option( "distname" , "dist name (0.8.0)" , 1 , False )
add_option( "distmod", "additional piece for full dist name" , 1 , False )
add_option( "nostrip", "do not strip installed binaries" , 0 , False )
add_option( "extra-variant-dirs", "extra variant dir components, separated by commas", 1, False)
add_option( "add-branch-to-variant-dir", "add current git branch to the variant dir", 0, False )
add_option( "variant-dir", "override variant subdirectory", 1, False )

add_option( "sharedclient", "build a libmongoclient.so/.dll [DEPRECATED/IGNORED]" , 0 , False )
add_option( "full", "include client and headers when doing scons install [DEPRECATED/IGNORED]", 0 , False )

# linking options
add_option( "release" , "release build" , 0 , True )
add_option( "static" , "fully static build" , 0 , False )
add_option( "static-libstdc++" , "statically link libstdc++" , 0 , False )
add_option( "lto", "enable link time optimizations (experimental, except with MSVC)" , 0 , True )
add_option( "dynamic-windows", "dynamically link on Windows", 0, True)
add_option( "disable-declspec-thread", "don't use __declspec(thread) on Windows [DEPRECATED/IGNORED]", 0, True)

# base compile flags
add_option( "64" , "whether to force 64 bit" , 0 , True , "force64" )
add_option( "32" , "whether to force 32 bit" , 0 , True , "force32" )

add_option( "cxx", "compiler to use" , 1 , True )
add_option( "cc", "compiler to use for c" , 1 , True )
add_option( "cc-use-shell-environment", "use $CC from shell for C compiler" , 0 , False )
add_option( "cxx-use-shell-environment", "use $CXX from shell for C++ compiler" , 0 , False )
add_option( "ld", "linker to use" , 1 , True )
add_option( "c++11", "enable c++11 support (experimental)", 0, True )

add_option( "cpppath", "Include path if you have headers in a nonstandard directory" , 1 , False )
add_option( "libpath", "Library path if you have libraries in a nonstandard directory" , 1 , False )

add_option( "extrapath", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) static linking" , 1 , False )
add_option( "extrapathdyn", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) dynamic linking" , 1 , False )
add_option( "extralib", "comma separated list of libraries  (--extralib js_static,readline" , 1 , False )

add_option( "no-glibc-check" , "don't check for new versions of glibc" , 0 , False )

# experimental features
add_option( "mm", "use main memory instead of memory mapped files" , 0 , True )
add_option( "asio" , "Use Asynchronous IO (NOT READY YET)" , 0 , True )
add_option( "ssl" , "Enable SSL" , 0 , True )

# library choices
add_option( "usev8" , "use v8 for javascript" , 0 , True )
add_option( "libc++", "use libc++ (experimental, requires clang)", 0, True )

# mongo feature options
add_option( "noshell", "don't build shell" , 0 , True )
add_option( "safeshell", "don't let shell scripts run programs (still, don't run untrusted scripts)" , 0 , True )
add_option( "win2008plus",
            "use newer operating system API features (deprecated, use win-version-min instead)" ,
            0 , False )

# dev options
add_option( "d", "debug build no optimization, etc..." , 0 , True , "debugBuild" )
add_option( "dd", "debug build no optimization, additional debug logging, etc..." , 0 , True , "debugBuildAndLogging" )

# new style debug and optimize flags
add_option( "dbg", "Enable runtime debugging checks", 1, True, "dbg",
            type="choice", choices=["on", "off"] )

add_option( "opt", "Enable compile-time optimization", 1, True, "opt",
            type="choice", choices=["on", "off"] )

sanitizer_choices = ["address", "memory", "thread", "undefined"]
add_option( "sanitize", "enable selected sanitizer", 1, True,
            type="choice", choices=sanitizer_choices, default=None )

add_option( "durableDefaultOn" , "have durable default to on" , 0 , True )
add_option( "durableDefaultOff" , "have durable default to off" , 0 , True )

add_option( "pch" , "use precompiled headers to speed up the build (experimental)" , 0 , True , "usePCH" )
add_option( "distcc" , "use distcc for distributing builds" , 0 , False )

# debugging/profiling help
if os.sys.platform.startswith("linux") and (os.uname()[-1] == 'x86_64'):
    defaultAllocator = 'tcmalloc'
elif (os.sys.platform == "darwin") and (os.uname()[-1] == 'x86_64'):
    defaultAllocator = 'tcmalloc'
else:
    defaultAllocator = 'system'
add_option( "allocator" , "allocator to use (tcmalloc or system)" , 1 , True,
            default=defaultAllocator )
add_option( "gdbserver" , "build in gdb server support" , 0 , True )
add_option( "heapcheck", "link to heap-checking malloc-lib and look for memory leaks during tests" , 0 , False )
add_option( "gcov" , "compile with flags for gcov" , 0 , True )

add_option("smokedbprefix", "prefix to dbpath et al. for smoke tests", 1 , False )
add_option("smokeauth", "run smoke tests with --auth", 0 , False )

add_option("use-sasl-client", "Support SASL authentication in the client library", 0, False)

add_option( "use-system-tcmalloc", "use system version of tcmalloc library", 0, True )

add_option( "use-system-pcre", "use system version of pcre library", 0, True )

add_option( "use-system-boost", "use system version of boost libraries", 0, True )

add_option( "use-system-snappy", "use system version of snappy library", 0, True )

add_option( "use-system-v8", "use system version of v8 library", 0, True )

add_option( "use-system-stemmer", "use system version of stemmer", 0, True )

add_option( "use-system-yaml", "use system version of yaml", 0, True )

add_option( "use-system-all" , "use all system libraries", 0 , True )

add_option( "use-cpu-profiler",
            "Link against the google-perftools profiler library",
            0, False )

add_option("mongod-concurrency-level", "Concurrency level, \"global\" or \"db\"", 1, True,
           type="choice", choices=["global", "db"])

add_option('build-fast-and-loose', "NEVER for production builds", 0, False)

add_option('disable-warnings-as-errors', "Don't add -Werror to compiler command line", 0, False)

add_option('propagate-shell-environment',
           "Pass shell environment to sub-processes (NEVER for production builds)",
           0, False)

if darwin:
    osx_version_choices = ['10.6', '10.7', '10.8', '10.9']
    add_option("osx-version-min", "minimum OS X version to support", 1, True,
               type = 'choice', default = osx_version_choices[0], choices = osx_version_choices)

elif windows:
    win_version_min_choices = {
        'xpsp3'   : ('0501', '0300'),
        'ws03sp2' : ('0502', '0200'),
        'vista'   : ('0600', '0000'),
        'ws08r2'  : ('0601', '0000'),
        'win7'    : ('0601', '0000'),
        'win8'    : ('0602', '0000'),
    }

    add_option("win-version-min", "minimum Windows version to support", 1, True,
               type = 'choice', default = None,
               choices = win_version_min_choices.keys())

add_option('cache',
           "Use an object cache rather than a per-build variant directory (experimental)",
           0, False)

add_option('cache-dir',
           "Specify the directory to use for caching objects if --cache is in use",
           1, False, default="#build/cached/.cache")

# don't run configure if user calls --help
if GetOption('help'):
    Return()

# --- environment setup ---

variantDir = get_variant_dir()

def printLocalInfo():
    import sys, SCons

=== debian/changelog ===
mongodb (1:2.6.3-0ubuntu6) vivid; urgency=medium

  * debian/rules: Fix typo to actually enable dh-systemd.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Sun, 08 Mar 2015 12:37:52 +0100

mongodb (1:2.6.3-0ubuntu5) utopic; urgency=medium

  * d/p/fix-signed-checks.patch: Fixup comparisons between signed and
    unsigned int, cause of FTBFS on previous upload. 

 -- James Page <james.page@ubuntu.com>  Fri, 15 Aug 2014 15:11:22 +0100

mongodb (1:2.6.3-0ubuntu4) utopic; urgency=medium

  * d/control: Drop dependency between mongodb->mongodb-dev which was
    dropped in 1:2.6.3-0ubuntu1. 

 -- James Page <james.page@ubuntu.com>  Tue, 12 Aug 2014 17:49:05 +0100

mongodb (1:2.6.3-0ubuntu3) utopic; urgency=medium

  * d/test/mongo-client: Use a core basic test to resolve autopkgtest
    failure.

 -- James Page <james.page@ubuntu.com>  Mon, 14 Jul 2014 09:58:39 +0100

mongodb (1:2.6.3-0ubuntu2) utopic; urgency=medium

  * d/test/mongo-client: Update test case for new location of basic
    scripting test.
  * d/p/0001-Add-option-to-disable-javascript.patch: Add matchertests.cpp to
    exclusions list if scripting is disabled, fixing FTBFS on arm64.

 -- James Page <james.page@ubuntu.com>  Thu, 03 Jul 2014 11:20:38 +0100

mongodb (1:2.6.3-0ubuntu1) utopic; urgency=medium

  * New upstream stable release:
    - Dropped patches, included upstream:
      + 0003-All-platforms-but-Windows-find-hash-in-std-tr1.patch
      + 0008-Use-system-libstemmer.patch
      + 0011-Use-a-signed-char-to-store-BSONType-enumerations.patch
      + 0001-SERVER-12064-Atomic-operations-for-gcc-non-Intel-arc.patch
      + 0002-SERVER-12065-Support-ARM-and-AArch64-builds.patch
    - d/p/*: Refreshed/rebased remaining patches.
    - Use system provided libyaml-cpp:
      + d/control: Add libyaml-cpp-dev to BD's.
      + d/rules: Enable --with-system-yaml option.
      + d/p/fix-yaml-detection.patch: Fix detection of libyaml-cpp library.
    - d/mongodb-server.mongodb.upstart: Sync changes from upstream.
    - d/control,mongodb-dev.*: Drop mongodb-dev package; it has no reverse
      dependencies and upstream no longer install header files.
    - d/NEWS: Point users to upstream upgrade documentation for upgrades
      from 2.4 to 2.6.
  * Merge from Debian unstable.
  * d/control: BD on libv8-3.14-dev to ensure that transitioning to new v8
    versions is a explicit action due to changes in behaviour in >= 3.25
    (LP: #1295723).
  * d/mongodb-server.prerm: Dropped debug echo call from maintainer script
    (LP: #1294455).

 -- James Page <james.page@ubuntu.com>  Thu, 03 Jul 2014 09:23:46 +0100

mongodb (1:2.4.10-1ubuntu1) utopic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add support for arm64:
      + d/control: Add arm64 to list of target architectures.
      + d/p/0001-Add-option-to-disable-javascript.patch,
        d/p/0001-SERVER-12064-Atomic-operations-for-gcc-non-Intel-arc.patch,
        d/p/0002-SERVER-12065-Support-ARM-and-AArch64-builds.patch:
        Patches to support arm64.
      + d/p/0005-ARM-support-for-ASM-operations-in-MongoDB.patch: Dropped in
        preference to above patches.
      + d/rules: Disable scripting on arm64.
    - d/p/0004-Support-ppc64el-builds.patch: Rebase on arm64 patches.
  * d/mongodb-server.postinst: Call adduser with explicit --home.

 -- James Page <james.page@ubuntu.com>  Mon, 19 May 2014 15:46:36 +0100

mongodb (1:2.4.9-1ubuntu3) utopic; urgency=high

  * No change rebuild against boost1.55.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 29 Apr 2014 04:19:06 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_SCONS_OPTIONS :=
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif
ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
       PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += -j$(PROCS)
endif

HARDENING_OPTIONS = CC="$(CC)" CFLAGS="$(CFLAGS)" \
  CXX="$(CXX)" CXXFLAGS="$(CXXFLAGS)"
COMMON_OPTIONS = --use-system-snappy --use-system-pcre \
  --use-system-boost --use-system-v8 --use-system-yaml \
  --ssl $(DEB_SCONS_OPTIONS)

gperftools_archs = amd64 i386 armhf ppc64el
ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
COMMON_OPTIONS += --allocator=tcmalloc --use-system-tcmalloc
else
COMMON_OPTIONS += --allocator=system
endif

ifeq ($(DEB_HOST_ARCH), arm64)
COMMON_OPTIONS += --disable-scripting
endif

DEB_SCONS_CLEAN = --directory="." $(HARDENING_OPTIONS) . --keep-going --clean \
  $(COMMON_OPTIONS)
DEB_SCONS_BUILD = --directory="." $(HARDENING_OPTIONS) all $(COMMON_OPTIONS)
DEB_SCONS_CHECK = --smokedbprefix=$(CURDIR)/debian/tmp-test smoke \
  $(COMMON_OPTIONS)
DEB_SCONS_INSTALL = --directory="." $(HARDENING_OPTIONS) \
  --prefix=$(CURDIR)/debian/tmp/usr install --full $(COMMON_OPTIONS)

override_dh_clean:
	scons $(DEB_SCONS_CLEAN)
	find $(CURDIR)/ -name "*.pyc" -delete
	rm -rf $(CURDIR)/debian/tmp-test/
	rm -rf $(CURDIR)/.scons/
	rm -rf $(CURDIR)/build/
	rm -f $(CURDIR)/failfile.smoke $(CURDIR)/smoke-last.json
	dh_clean

override_dh_auto_build:
	scons $(DEB_SCONS_BUILD)

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	scons $(DEB_SCONS_CHECK)
endif

override_dh_auto_install:
	scons $(DEB_SCONS_INSTALL)

override_dh_installinit:
	dh_installinit -pmongodb-server --name=mongodb

ifeq ($(DEB_HOST_ARCH), arm64)
# mongo shell is broken without scripting so drop it from
# the binary
override_dh_install:
	dh_install
	rm -f $(CURDIR)/tmp/mongodb-clients/usr/bin/mongo
endif

%:
	dh $@ --parallel --with systemd

.PHONY: override_dh_clean override_dh_auto_build override_dh_auto_test \
	override_dh_auto_install override_dh_installinit

## mongodb 2.6.10

=== debian/changelog ===
mongodb (1:2.6.10-0ubuntu1) wily; urgency=medium

  * New upstream release
  * Fix FTBFS: (LP: #1483400)
    - Add 00git_boost_1.56.patch: Fix "std::swap" failure with current boost.
    - Add disable-warnings.patch: Don't fail to build on "unused-variable" and
      "maybe-uninitialized" warnings (new from g++ 5).

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 11 Aug 2015 10:19:10 +0200

mongodb (1:2.6.3-0ubuntu8) wily; urgency=medium

  * No-change rebuild against libpcrecpp0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 08 Aug 2015 23:36:33 +0000

mongodb (1:2.6.3-0ubuntu7) vivid; urgency=medium

  * debian/rules: Call dh_systemd_enable for mongodb-server.mongodb.service.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 09 Mar 2015 07:15:33 +0100

=== debian/control ===
Source: mongodb
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>
Build-Depends:
 debhelper (>= 9),
 dh-systemd (>= 1.5),
 libboost-date-time-dev,
 libboost-dev (>> 1.50),
 libboost-filesystem-dev,
 libboost-program-options-dev,
 libboost-thread-dev,
 libgoogle-perftools-dev [linux-amd64 linux-i386 armhf ppc64el],
 libpcap-dev,
 libpcre3-dev,
 libreadline-dev,
 libsnappy-dev,
 libssl-dev,
 libstemmer-dev,
 libv8-3.14-dev (>= 3.12) [!arm64],
 libyaml-cpp-dev,
 python-pymongo,
 scons
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/collab-maint/mongodb.git
Vcs-Browser: http://anonscm.debian.org/git/collab-maint/mongodb.git
Homepage: http://www.mongodb.org
XS-Testsuite: autopkgtest

Package: mongodb
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el arm64
Depends:
 mongodb-server (>= 1:2.4.1-2),
 ${misc:Depends},
 ${shlibs:Depends}
Description: object/document-oriented database (metapackage)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This is a convenience metapackage that depends on all the mongodb parts:
 the server and the clients.

Package: mongodb-server
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el arm64
Depends:
 adduser,
 mongodb-clients,
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (server package)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the server itself  (mongod) and the sharding
 server/load-balancer (mongos).

Package: mongodb-clients
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el arm64
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (client apps)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the standard administrative shell (mongo) and other
 utilities for administration or analysis of performance of the server.

=== debian/rules ===
--- 
+++ 
@@ -61,6 +61,9 @@
 override_dh_auto_install:
 	scons $(DEB_SCONS_INSTALL)
 
+override_dh_systemd_enable:
+	dh_systemd_enable -pmongodb-server --name=mongodb
+
 override_dh_installinit:
 	dh_installinit -pmongodb-server --name=mongodb

## mongodb 2.6.11

=== SConstruct ===
--- 
+++ 
@@ -96,7 +96,7 @@
     if type == 'choice' and not metavar:
         metavar = '[' + '|'.join(choices) + ']'
 
-    AddOption( "--" + name , 
+    AddOption( "--" + name ,
                dest=dest,
                type=type,
                nargs=nargs,
@@ -133,7 +133,7 @@
 
 def get_variant_dir():
     if has_option('variant-dir'):
-        return "#build/" + get_option('variant-dir') 
+        return "#build/" + get_option('variant-dir')
 
     substitute = lambda x: re.sub( "[:,\\\\/]" , "_" , x )

=== debian/changelog ===
mongodb (1:2.6.11-1ubuntu1) yakkety; urgency=medium

  * Sync with Debian. Remaining change:
    - debian/control, debian/rules:
      + Use libv8-dev on ppc64el too since it exists in Ubuntu

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 08 Jul 2016 18:07:18 -0400

mongodb (1:2.6.11-1) experimental; urgency=medium

  * New upstream release (closes: #748490).
  * Drop patches merged upstream:
    + 0003-All-platforms-but-Windows-find-hash-in-std-tr1.patch
    + 0005-ARM-support-for-ASM-operations-in-MongoDB.patch
    + 0008-Use-system-libstemmer.patch
    + 0010-fix-integer-signs.patch
    + 0011-Use-a-signed-char-to-store-BSONType-enumerations.patch
    + 0013-pymongo.patch
  * Drop 0007-Use-TIME_UTC_-macro.patch: essentially no-op with Jessie's boost
    version.
  * Drop 0009-ignore-unused-local-typedefs.patch: it only patches v8's
    SConstruct for 2.6.11, but we use the system's v8 library anyway.
  * Replace no-unused-variable.patch with Ubuntu's version, which also
    specifies the (required) -Wno-maybe-uninitialized option.
  * Refresh remaining patches.
  * d/control:
    + Add myself to Uploaders.
    + Remove ancient g++ version B-D.
    + Move adduser from Pre-Depends to Depends.
    + Use HTTPS for all URLs.
    + Remove XS-Testsuite: autopkgtest; it is added automatically.
    + Drop the mongodb-dev binary package. The C++ client library is now
      developed separately from the mongo database server.
    + Lower libboost-dev B-D version requirement to (>> 1.50) to ease backports.
    + Remove the libsnappy-dev B-D version restriction.
  * d/rules: various fixes:
    + Replace the individual --use-system-x scons arguments with a
      single --use-system-all.
    + Create -dbgsym packages by default, can be disabled using
      DEB_BUILD_OPTIONS=nodbgsym (Warning: -dbgsym packages are about 1GB big
      in total).
    + lint: use filter instead of findstring.
    + Really pass the hardening flags to scons through environment variables;
      introduced a new patch for SConstruct.
    + Honour the nocheck build option.
    + Use dh_install --list-missing.
    + Move dh_clean handling to debian/clean and override dh_auto_clean
      instead.
    + Use a dedicated override for dh_systemd_enable.
  * Use system YAML:
    + d/control: B-D on libyaml-cpp-dev
    + Include a patch from Ubuntu fixing yaml-cpp detection.
  * tests: update basic1.js' location.
  * mongodb.service: specify RuntimeDirectory and RuntimeDirectoryMode to have
    systemd create /run/mongodb.
  * upstart: create /run/mongodb
  * mongodb-server.postinst:
    + Do not create /run/mongodb on installation; this is a
      runtime directory created by the initscript, the systemd unit and the
      upstart job.
    + Use dpkg-statoverride to set directory permissions. Also do not
      create /var/lib/mongodb and /var/log/mongodb, they are already created
      using dh_installdirs.
    + Refactor user creation; create the mongodb system user with
      mongodb as primary group and with disabled login and shell.
  * Drop mongodb-server.{prerm,postrm}; they are essentially dh_make
    boilerplate.
  * mongodb.service: source /etc/default/mongodb and use $CONF and $DAEMON_OPTS.
  * Remove obsolete mongodb maintainer scripts, initscript, upstart job and
    dirs.
  * Remove old xulrunner-related lintian overrides.
  * Remove duplicate manpages from debian/.
  * Enable arm64 and ppc64el builds (closes: #791935):
    + Add a patch from Ubuntu to allow disabling javascript during build.
    + Disable javascript for arm64 and ppc64el builds, as V8 is not available
      on these architectures.
    + d/control: mark packages additionally as arm64 and ppc64el.
    + Drop the mongo shell from the arm64 and ppc64el packages, as it is
      broken without scripting support.
  * Use the tcmalloc allocator on supported architectures (amd64, i386, armhf,
    ppc64el).
  * Add debian/source/lintian-overrides, overriding false positive and
    irrelevant warnings/errors.
  * Remove debian/mongodb-clients.lintian-overrides: overrides were not used.
  * d/copyright: convert to Format 1.0.
  * Bump standards to 3.9.7; no changes needed.
  * d/watch: check for 2.6 stable releases.
  * Add NEWS entry with hints about the upgrade to 2.6.

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Tue, 15 Mar 2016 14:32:18 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Uploaders: Jérémy Lal <kapouer@melix.org>
+Uploaders: Jérémy Lal <kapouer@melix.org>,
+           Apollon Oikonomopoulos <apoikos@debian.org>
 Build-Depends:
  debhelper (>= 9),
  dh-systemd (>= 1.5),
@@ -13,28 +14,24 @@
  libboost-program-options-dev,
  libboost-thread-dev,
  libgoogle-perftools-dev [linux-amd64 linux-i386 armhf ppc64el],
+ libyaml-cpp-dev,
  libpcap-dev,
  libpcre3-dev,
  libreadline-dev,
  libsnappy-dev,
+ libstemmer-dev,
  libssl-dev,
- libstemmer-dev,
- libv8-3.14-dev (>= 3.12) [!arm64],
- libyaml-cpp-dev,
+ libv8-dev (>= 3.12) [!arm64],
  python-pymongo,
  scons
-Standards-Version: 3.9.5
-Vcs-Git: git://anonscm.debian.org/collab-maint/mongodb.git
-Vcs-Browser: http://anonscm.debian.org/git/collab-maint/mongodb.git
-Homepage: http://www.mongodb.org
-XS-Testsuite: autopkgtest
+Standards-Version: 3.9.7
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/mongodb.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mongodb.git/
+Homepage: https://www.mongodb.org
 
 Package: mongodb
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el arm64
-Depends:
- mongodb-server (>= 1:2.4.1-2),
- ${misc:Depends},
- ${shlibs:Depends}
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf arm64 ppc64el
+Depends: mongodb-server (>= 1:2.4.1-2), ${misc:Depends}, ${shlibs:Depends}
 Description: object/document-oriented database (metapackage)
  MongoDB is a high-performance, open source, schema-free
  document-oriented data store that's easy to deploy, manage
@@ -52,13 +49,13 @@
  functionality are the goals for the project.
  .
  This is a convenience metapackage that depends on all the mongodb parts:
- the server and the clients.
+ the server, the clients and the development files (headers and library).
 
 Package: mongodb-server
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el arm64
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf arm64 ppc64el
 Depends:
+ mongodb-clients,
  adduser,
- mongodb-clients,
  ${misc:Depends},
  ${shlibs:Depends}
 Replaces:
@@ -83,7 +80,7 @@
  server/load-balancer (mongos).
 
 Package: mongodb-clients
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf ppc64el arm64
+Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf arm64 ppc64el
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_SCONS_OPTIONS :=
ifneq (,$(filter debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif

ifeq (,$(filter nodbgsym,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += --nostrip
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += -j$(PROCS)
endif

COMMON_OPTIONS = --use-system-all --ssl $(DEB_SCONS_OPTIONS)

gperftools_archs = amd64 i386 armhf ppc64el
ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
COMMON_OPTIONS += --allocator=tcmalloc
else
COMMON_OPTIONS += --allocator=system
endif

no_v8_archs = arm64
ifneq (,$(filter $(DEB_HOST_ARCH), $(no_v8_archs)))
COMMON_OPTIONS += --disable-scripting
endif

override_dh_auto_clean:
	scons --keep-going --clean $(COMMON_OPTIONS) .

override_dh_auto_build:
	scons $(COMMON_OPTIONS) core tools

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	scons $(COMMON_OPTIONS) \
		--smokedbprefix=$(CURDIR)/debian/tmp-test \
		test unittests moduletests smoke
.PHONY: override_dh_auto_test
endif

override_dh_auto_install:
	scons $(COMMON_OPTIONS) --prefix=$(CURDIR)/debian/tmp/usr install

override_dh_systemd_enable:
	dh_systemd_enable -pmongodb-server --name=mongodb

override_dh_installinit:
	dh_installinit -pmongodb-server --name=mongodb

override_dh_install:
	dh_install --list-missing
ifneq (,$(filter $(DEB_HOST_ARCH), $(no_v8_archs)))
	# mongo shell is broken without scripting so drop it from
	# the binary
	rm -f $(CURDIR)/tmp/mongodb-clients/usr/bin/mongo
endif

%:
	dh $@ --parallel --with=systemd

.PHONY: override_dh_auto_clean override_dh_auto_build \
	override_dh_auto_install override_dh_installinit \
	override_dh_systemd_enable override_dh_install

=== debian/tests/control ===
Tests: mongod mongo-client
Depends: mongodb-server, mongodb-clients, nmap, netcat

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)-(rc\d+)$/$1~$2/ \
http://www.mongodb.org/dl/src/ .*/mongodb-src-r(2\.6\..*)\.tar\.gz

## mongodb 2.6.12

=== debian/changelog ===
mongodb (1:2.6.12-2ubuntu2) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:46:43 +0000

mongodb (1:2.6.12-2ubuntu1) yakkety; urgency=medium

  * Sync with Debian. Remaining change:
    - debian/control, debian/rules:
      + Use libv8-dev on ppc64el too since it exists in Ubuntu

 -- Jeremy Bicha <jbicha@ubuntu.com>  Thu, 14 Jul 2016 20:04:02 -0400

mongodb (1:2.6.12-2) unstable; urgency=medium

  * Do not use tcmalloc on ppc64el (fixes FTBFS on ppc64el).

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Thu, 14 Jul 2016 15:13:57 +0300

mongodb (1:2.6.12-1) unstable; urgency=medium

  [ Apollon Oikonomopoulos ]
  * New upstream release
  * Upload to unstable
  * Fix FTBFS with GCC6 (Closes: #811606)

  [ Laszlo Boszormenyi ]
  * Bump standards to 3.9.8; no changes needed
  * Refresh hardened-build.patch

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Wed, 13 Jul 2016 12:38:13 +0300

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  libboost-filesystem-dev,
  libboost-program-options-dev,
  libboost-thread-dev,
- libgoogle-perftools-dev [linux-amd64 linux-i386 armhf ppc64el],
+ libgoogle-perftools-dev [linux-amd64 linux-i386 armhf],
  libyaml-cpp-dev,
  libpcap-dev,
  libpcre3-dev,
@@ -24,7 +24,7 @@
  libv8-dev (>= 3.12) [!arm64],
  python-pymongo,
  scons
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/mongodb.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mongodb.git/
 Homepage: https://www.mongodb.org

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 COMMON_OPTIONS = --use-system-all --ssl $(DEB_SCONS_OPTIONS)
 
-gperftools_archs = amd64 i386 armhf ppc64el
+gperftools_archs = amd64 i386 armhf
 ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
 COMMON_OPTIONS += --allocator=tcmalloc
 else
